#version 420

#ifndef RENDERSCALE_GLSL
#define RENDERSCALE_GLSL

float getRenderScale(sampler2D dataSampler) {
    return clamp(texelFetch(dataSampler, ivec2(3, 0), 0).r * 0.5 + 0.5, 0.5, 1.0);
}

vec4 scaleClipPos(vec4 clipPos, float renderScale) {
    return vec4((clipPos.xy + 1.0) * renderScale - 1.0, clipPos.zw);
}

#endif // RENDERSCALE_GLSL

in vec4 Position;

uniform mat4 ProjMat;
uniform sampler2D DataSampler;

out vec2 texCoord;
out float renderScale;

void main() {
    vec4 outPos = ProjMat * vec4(Position.xy, 0.0, 1.0);
    gl_Position = vec4(outPos.xy, 0.0, 1.0);
    texCoord = gl_Position.xy * 0.5 + 0.5;
    renderScale = getRenderScale(DataSampler);
}